package org.fenode;

import org.fenode.parse.FreemarkerParser;
import org.fenode.parse.VelocityParser;

/**
 * fe-node方案 应对java模版引擎
 * @author fe-gaoyong
 * @data 2016.05.20 17:24
 * 
 * @interface 通过java -jar 执行方式传入 
 * 		1. type类型 [ freemarker/velocity ] 目前支持freemarker,计划中还包括velocity 其他no support
 * 		2.JSON字符串  有全部的解析模版引擎需要的文件路径配置信息
 * 		例如:
 * 				fileInfo : {
 * 					dirpath:'', // 模版文件所在目录的目录名
 * 					filename:'' // 模版文件名，必需包含文件后缀 否则不解析
 * 				}
 * 		3. JSON字符串  有全部的HTTP请求头信息
 * 				httpInfo : {
 * 					// some http protocal header infos.
 * 				}	
 */


public class Main {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		// 得到命令行传入的参数
		try {
			String templateType = args[0];
			String templateFileConfig = args[1];
			String httpInfoConfig = args[2];
			
			//debug
//			String templateType = "freemarker";
//			String templateFileConfig = "{'dirpath':'/Users/gaoyong/documents/working/svn/statics/zt.xiaoying.com/xqx201603/','filename':'award.ftl'}";
//			String httpInfoConfig = "";
			
			if ( templateType.equals("freemarker") ) {
				FreemarkerParser.parse(templateFileConfig,httpInfoConfig);
			} else if ( templateType.equals("velocity") ) {
				VelocityParser.parse(templateFileConfig,httpInfoConfig);
			} else {
				Exception e = new Exception("不支持除freemarker velcity外的其他java模版引擎!");
				throw e;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}

