package org.fenode.parse;

import java.io.File;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.Charset;
import java.util.Locale;

import org.codehaus.jackson.JsonParseException;
import org.codehaus.jackson.map.JsonMappingException;

import freemarker.template.Configuration;
import freemarker.template.DefaultObjectWrapper;
import freemarker.template.Template;
import freemarker.template.TemplateException;

public class FreemarkerParser extends TemplateEngineParser {
	private Configuration cfg = null;
	
	public FreemarkerParser () {
		super();
		this.cfg = new Configuration();
	}
	
	/**
	 * 解析ftl文件到控制台
	 */
	private void ftl2html () throws IOException, TemplateException {
		// 得到路径信息
		String dirpath = "",filename = "";
		if ( null != this.templateFileInfo ) {
			dirpath = (String) this.templateFileInfo.get("dirpath");
			filename = (String) this.templateFileInfo.get("filename");
			
			dirpath = dirpath.replaceAll("\\\\", "/");
		}
//		dirpath = "/Users/gaoyong/documents/working/svn/statics/zt.xiaoying.com/xqx201603/";
//		filename = "award.ftl";
		
		this.cfg.setDirectoryForTemplateLoading( new File(dirpath) );
		this.cfg.setAutoFlush(true);
		this.cfg.setDefaultEncoding("UTF-8");
		this.cfg.setEncoding(Locale.CHINA, "UTF-8");
		this.cfg.setObjectWrapper(new DefaultObjectWrapper());
		Template t = this.cfg.getTemplate(filename,Locale.CHINA);
		Writer out = null;
		try {
			out = new OutputStreamWriter(System.out, Charset.forName("UTF-8").newEncoder());
			t.process(this.mockData(), out);
			out.flush();
		} catch (Exception e) {
			throw e;
		} finally {
			try {
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * 解析flt并将最终信息输出到控制台
	 * @param fileJSON
	 * @param httpJSON
	 * @throws JsonParseException
	 * @throws JsonMappingException
	 * @throws IOException
	 * @throws Exception
	 */
	public static void parse (String fileJSON,String httpJSON) throws TemplateException,JsonParseException, JsonMappingException, IOException,Exception {
		FreemarkerParser ftl = new FreemarkerParser();
		ftl.parseInfo(fileJSON, httpJSON);
		ftl.ftl2html();
	}
}
