package org.fenode.parse;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.Charset;
import java.util.Map;
import java.util.Map.Entry;
import java.util.HashMap;
import java.util.Properties;
import java.util.Iterator;

import org.codehaus.jackson.JsonParseException;
import org.codehaus.jackson.map.JsonMappingException;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;


public class VelocityParser extends TemplateEngineParser {
	
	public VelocityParser () {
		super();
		
	}
	
	/**
	 * 解析vm文件到控制台
	 */
	private void vm2html () throws Exception {
		// 得到路径信息
		String dirpath = "",filename = "";
		if ( null != this.templateFileInfo ) {
			dirpath = (String) this.templateFileInfo.get("dirpath");
			filename = (String) this.templateFileInfo.get("filename");
			
			dirpath = dirpath.replaceAll("\\\\", "/");
		}
				
		// 1.初始化并取得Velocity引擎
		VelocityEngine ve = new VelocityEngine();
		Properties properties = new Properties();
		properties.setProperty(ve.FILE_RESOURCE_LOADER_PATH, dirpath);
		properties.setProperty(ve.INPUT_ENCODING,"UTF-8");
		ve.init(properties);   //初始化

		// 2.取得velocity的上下文context
		VelocityContext context = new VelocityContext();
		// 3.把数据填入上下文
		final HashMap<String,Object> mockData = this.mockData();
		// 遍历hashMap,将http 信息放入上下文中
		Iterator iter = mockData.entrySet().iterator();
		while ( iter.hasNext() ) {
			Entry entry = (Entry) iter.next();
			String key = (String) entry.getKey();
			Object value = (Object) entry.getValue();
			context.put(key, value);
		}
		

		// 4. 取得velocity的模版
		Template t = ve.getTemplate( filename );
		// 5. 输出流
		Writer out = null;
		out = new OutputStreamWriter(System.out, Charset.forName("UTF-8").newEncoder());
		t.merge(context, out);
		out.flush();
	}
	
	public static void parse ( final String fileJSON,final String httpJSON ) throws JsonParseException, JsonMappingException, IOException,Exception {
		VelocityParser vm = new VelocityParser();
		vm.parseInfo(fileJSON, httpJSON);
		vm.vm2html();
	}
}
