#!/usr/bin/env node
'use strict'

/**
 *  fn-server 入口
 *  @fun : 入口检测
 */
// 引包
const fs = require('fs');
const path = require('path');

const appManager = require('./src/util/appManager.js');
const service = require('./src/service/index.js');
const manager = require('./src/manager/index.js');

//初始化
const licenseFilePaht = path.join(__dirname,'license.txt');
const cmdArgs = process.argv;

/**
*  命令行键值对转换函数
*/
function cmdArg2Obj ( arr ) {
    let obj = {};
    if ( Array.isArray(arr) && arr.length > 0 ) {
        arr.forEach( function (val) {
            val = val.split('=');

            let key = val[0],value = val[1];
            obj[''+key] = value;
        } );
    }

    return obj;
}


let port,webPort;
if ( typeof cmdArgs.length > 2 ) {
    const _cmdArgs = cmdArgs.clice(2);
    const _cmdObj = cmdArg2Obj( _cmdArgs );

    if ( _cmdObj['port'] ) {
        port = _cmdObj['port'];
        port = parseInt( port );
        if ( !isNaN(port) && port > appManager.getMinPort() ) {
            // 代码必需比较端口port是否大于9000 这样保险些
            port = +port;
        } else {
            console.log('port nust be larger than 9000 or port is invalid.');
            return false;
        }
    }

    if ( _cmdObj['webPort'] ) {
        webPort = _cmdObj['webPort'];
        webPort = parseInt( webPort );
        if ( !isNaN(webPort) && webPort < appManager.getMinPort() ) {
            // 代码必需比较端口port是否小于9000 这样保险些
            webPort = +webPort;
        } else {
            console.log('webPort nust be larger than 9000 or webPort is invalid.');
            return false;
        }
    }
}
// license声明
let license = fs.readFileSync(licenseFilePaht,{encoding:'utf8'});
console.log( `作者声明: \n${license}\n` );
console.log('---------------------------\n\n');

// 保存端口
let ports = appManager.savePorts({
    port: port,
    webPort: webPort
});

// 启动http服务器
service.init( ports.port );

// 启动web配置服务器
manager.init( ports.webPort );


