'use strict'
/**
 * Created by gaoyong on 16/5/27.
 */
const fs = require('fs');
const path = require('path');

const httpRequest = require('../util/httpRequest.js');
const pageRender = require('./pageRender.js');
const ajaxService = require('./ajaxService.js');

function middleware (context,next) {
    return new Promise( function (resolve,reject) {
        // 封装http请求
        const httpReq = httpRequest(context);

        // 首先扫描页面渲染
        pageRender(context,httpReq).then( function (data) {
            if ( data ) {
                resolve(true);
            } else {
                // 其次扫描ajax请求
                return ajaxService(context,httpReq);
            }
        } ).then( function (data) {
            if ( data ) {
                resolve(true);
            } else {
                resolve(false);
            }
        } ).catch( function (e) {
            resolve(false);
        } );
    } );
}

// 中间件是否已被绑定上
let binded = false;
module.exports = function (app,route) {
    if ( !binded ) {
        binded = true;
        app.use( function* (next) {
            let ret = yield middleware(this,next);
            if ( !ret ) {
                yield next;
            }
        } );
    }
};
