'use strict'
/**
 * Created by gaoyong on 16/5/26.
 */
const fs = require('fs');
const path = require('path');

const koa = require('koa');
const app = koa();
const route = require('koa-router')();

const httpMiddleware = require('./httpMiddleware.js');

const appManager = require('../util/appManager.js');
const http404PagePath = path.join(__dirname,'../../config/404.html');

const work = function (port) {
    if ( !port ) {
        console.log(`service index.js port undefined`);
        return false;
    }

    // 拦截http请求是解析页面请求和json ajax get/post 请求
    httpMiddleware(app,route);

    // 404
    route.post('/**',function* () {
        this.body = yield Promise.resolve({ 'http state code' : '404' });
    });
    route.get('/**',function* () {
        this.body = yield (new Promise( function (resolve,reject) {
            fs.readFile(http404PagePath,'utf8',function (err,data) {
                if ( err ) {
                    reject('<strong>404</strong>>');
                }
                resolve(data);
            });
        } ));
    });

    app.use( route.routes() )
        .use( route.allowedMethods() );

    app.listen(port);
    console.log(`http service listening on port : ${port}`);
};

exports.init = function (port) {
    console.log('start init fe-node service...');

    work( port );
}

