'use strict'
/**
 * Created by fe-gaoyong on 16/5/30.
 */
const fs = require('fs');
const path = require('path');

const Render = require('./Render.js');

const artTemplate = require('art-template');

class HtmlRender extends Render {
    constructor () {
        super( arguments );
        let option = {
            base: '',
            openTag: '{{',
            closeTag: '}}',
            escape: false,
            cache: false
        };
        Object.keys(option).forEach( function (key) {
            artTemplate.config( key,option[''+key] );
        } );
    }

    /**
     * artTemplate 渲染器渲染函数
     *   @param filePath :    .html文件路径
     *   @param httpRequst : http request对象
     *   @param json :  页面渲染数据
     *   @return :  Promise
     */
    render ( filePath,httpRequst,json ) {
        let _this = this;

        return new Promise( function ( resolve,reject ) {
            try {
                _this._render(filePath,httpRequst,json,resolve,reject);
            } catch (e) {
                reject(false);
            }
        } );
    }

    /*
    *  artTemplate 渲染器渲染函数
    */
    _render ( filePath,httpRequst,json,resolve,reject ) {
        if ( path.isAbsolute(filePath) ) {
            try {
                filePath = filePath.replace(/(.*)\.html/,'$1');
                let html = artTemplate(filePath,json);
                resolve( html );
            } catch (e) {
                reject(false);
            }
        } else {
            reject(false);
        }
    }

    toHTML ( dataStr,resolve,reject ) {
        resolve( dataStr );
    }
}

module.exports = HtmlRender;

