'use strict'
/**
*  文件工具类
*   @author: fe-gaoyong
*   @date: 2016.07.05
*     说明 本文件中  fileExists函数取自github下https://github.com/scottcorgan/file-exists
*/
var fs = require('fs')
var path = require('path')

const fileUtil = {
	fileExists: function ( filepath, options ) {
		options = options || {}

		if (!filepath) return false

		var root = options.root
		var fullpath = (root) ? path.join(root, filepath) : filepath

		try {
		  return fs.statSync(fullpath).isFile()
		} catch (e) {
		  return false
		}
	}
};

module.exports = fileUtil;

